"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Comment(ProtocolElement):
    """
    A generic comment.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "date",
        "text",
        "userid",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import cva as cva_1_5_3

        return {
            "org.gel.models.cva.avro.Comment": cva_1_5_3.Comment,
        }

    __slots__ = [
        "date",
        "text",
        "userid",
    ]

    def __init__(
        self,
        date,
        text,
        userid,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.Comment model.

        :param date:
            Date in format yyyyMMddhhmm
        :type date: str
        :param text:
            The text of the comment
        :type text: str
        :param userid:
            The author of the curation event
        :type userid: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
